#ifndef TBOARD
#define TBOARD

#include "constants.h"

class TBoard
{
  private:
    //Variables para dibujo de ventanas de ncurses
    WINDOW *W_mi_campo;
    WINDOW *W_campo_enemigo;
    WINDOW *W_comandos;

    int parent_x;
    int parent_y;
    int player;

    //Punteros a los buffer que estan en memoria compartida
    BUFFER **campo_mio;
    BUFFER **campo_enemigo;

    //declaracion de funciones dentro de la clase
    void coloca_coordenada_mem(int user_y, int user_x, int modo);
    void refresca_desde_memoria(int i, WINDOW *v, char dibujo);
    void refresca_coordenada_enemiga(int index);
    void refresca_coordenada_mia(int index);
  public:
    bool continuar;
    TBoard(WINDOW *_W_mi_campo, WINDOW *_W_campo_enemigo, WINDOW *_W_comandos, int y, int x, int player);
    void create_shared_memory();
    void read_shared_memory();
    void start(int debug_level);
    bool revisar_si_perdi();
    bool revisar_si_gane();
    void turno(int user_y, int user_x);
    void turno();
    void draw_board(int y, int x, WINDOW *ventana);
    int letra_a_entero(char user_input);
    int ask_integer(int offset, const char *texto);
    char ask_char(int offset, const char *texto);

    void pinta_punto(int user_y, int user_x, int tipo);
    void pinta_punto(int user_y, int user_x, int tipo, WINDOW *ventana);
    void dibuja_barco(char orientacion, int user_y, int user_x);
    void fuego(int user_y, int user_x);
    void insert_boats(unsigned int n);
    void actualizar_todos_tableros();
    void actualiza_mi_tablero();

    //Metodos para debuguear
    void insert_boats_auto();
    void log(const char *texto);
    void log(const char *texto, int numero);
};

#endif
