#include "constants.h"
#include "TBoard.h"

#define DEBUG 0
BUFFER *buf[100];
BUFFER *buf_sp[100];
BUFFER *buf_turno[1];
//int *array[110];
int shmid[110];
int shmid_sp[110];
int shmid_turno;

int main (int argc, char * argv[]) {
  int parent_x, parent_y;

  //Inicializacion de ncurses
  initscr();
  //noecho();
  //curs_set(FALSE);
  start_color();
  init_pair(1, COLOR_RED, COLOR_BLACK);
  init_pair(2, COLOR_YELLOW, COLOR_BLACK);
  init_pair(3, COLOR_BLUE, COLOR_BLACK);

  //Obtiene el tamanio de la pantalla
  getmaxyx(stdscr, parent_y, parent_x);

  //Trabajaremos con 3 ventanas (WINDOW), una para mi campo con mis barcos,
  //otra con el campo del enemigo (donde yo selecciono mis disparos) y por
  //ultimo una ventana de comandos, en donde el jugador ingresara sus comandos
  WINDOW *W_mi_campo = newwin(parent_y - TAMANIO_COMANDOS, parent_x/2, 0, 0);
  WINDOW *W_campo_enemigo = newwin(parent_y - TAMANIO_COMANDOS, parent_x/2, 0, parent_x/2);
  WINDOW *W_comandos = newwin(TAMANIO_COMANDOS, parent_x, parent_y - TAMANIO_COMANDOS, 0);


#if DEBUG == 0
  //ambos jugadores deben insertar barcos
  if(argc==1){
    TBoard Board(W_mi_campo, W_campo_enemigo, W_comandos, parent_y, parent_x, 1);
    int n_barcos = Board.ask_integer(0,     "Con cuantos barcos deseas jugar ? ");
    Board.log("Primer jugador");
    wgetch(W_comandos);
    //Se va a la rutina de insertar barcos (insert_boats), en donde itera sobre la
    //cantidad de barcos con que se va a jugar, y en cada iteracion le pide al
    //jugador la coordenada del barco y su orientacion
    Board.insert_boats((unsigned int) n_barcos);
    Board.log("Espere a que el otro jugador coloque sus barcos. Presione <enter> cuando este listo");
    wgetch(W_comandos);
    while (Board.continuar) {
      Board.turno();
    }
    Board.actualizar_todos_tableros();
    Board.log("EL FIN");
  }
  else{
    TBoard Board(W_mi_campo, W_campo_enemigo, W_comandos, parent_y, parent_x, 2);
    int n_barcos = Board.ask_integer(0,     "Con cuantos barcos deseas jugar ? ");
    Board.log("Segundo jugador");
    wgetch(W_comandos);
    Board.insert_boats((unsigned int) n_barcos);
    Board.log("Espere a que el otro jugador coloque sus barcos. Presione <enter> cuando este listo");
    wgetch(W_comandos);
    while (Board.continuar) {
      Board.turno();
    }
    Board.actualizar_todos_tableros();
    Board.log("EL FIN");
  }
#elif DEBUG == 1
  int auto_fire_x[12] = {1, 2, 3, 4, 4, 4, 4, 6, 5, 7, 8, 3};
  int auto_fire_y[12] = {1, 2, 2, 2, 4, 5, 6, 6, 5, 6, 6, 3};
  if(argc==1){ //primer jugador crear memoria compartida
    TBoard Board(W_mi_campo, W_campo_enemigo, W_comandos, parent_y, parent_x, 1);
    Board.log("Primer jugador");
    wgetch(W_comandos);
    Board.insert_boats_auto();
    for (unsigned int i=0; i<11; i++) {
      Board.turno(auto_fire_y[i], auto_fire_x[i]);
      if (!Board.continuar)
        break;
    }
    Board.actualizar_todos_tableros();
    Board.log("FIN");
  }
  else{
    TBoard Board(W_mi_campo, W_campo_enemigo, W_comandos, parent_y, parent_x, 2);
    Board.log("Segundo jugador");
    wgetch(W_comandos);
    Board.insert_boats_auto();
    for (unsigned int i=0; i<11; i++) {
      Board.turno(auto_fire_y[i], auto_fire_x[i]);
      if (!Board.continuar)
        break;
    }
    Board.actualizar_todos_tableros();
    Board.log("FIN");
  }
#endif

  //Presione cualquier caracter para continuar, a continuacion cierra todas las
  //ventas y abandona el modo curses
  wgetch(W_campo_enemigo);
  delwin(W_mi_campo);
  delwin(W_campo_enemigo);
  delwin(W_comandos);
  endwin();

  return 0;
}

